# coding: utf-8


"""
IGNORE:
    Nutanix Aiops Versioned APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.2-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_aiops_py_client.Ntnx.aiops.v4.blackout.BlackoutPeriod import BlackoutPeriod  # noqa: F401,E501
from ntnx_aiops_py_client.Ntnx.aiops.v4.blackout.Operation import Operation  # noqa: F401,E501
from ntnx_aiops_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_aiops_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class BlackoutOperation(ExternalizableAbstractModel):
    """BlackoutOperation - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'operation': 'aiops.v4.blackout.Operation',
        'blackout_period': 'aiops.v4.blackout.BlackoutPeriod',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'operation': 'operation',
        'blackout_period': 'blackoutPeriod',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, operation=None, blackout_period=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """BlackoutOperation - a model defined in Swagger
            
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__operation = None
        self.__blackout_period = None
        self.discriminator = None
        if operation is not None:
            self.__operation = operation
        if blackout_period is not None:
            self.__blackout_period = blackout_period

    def _initialize_object_type(self):
        return 'aiops.v4.blackout.BlackoutOperation'

    def _initialize_fq_object_type(self):
        return 'aiops.v4.r0.a1.blackout.BlackoutOperation'


    @property
    def operation(self):
        """`{ aiops.v4.blackout.Operation }`
            
        """ # noqa: E501
        return self.__operation

    @operation.setter
    def operation(self, operation):

        self.__operation = operation

    @property
    def blackout_period(self):
        """`{ aiops.v4.blackout.BlackoutPeriod }`
            
        """ # noqa: E501
        return self.__blackout_period

    @blackout_period.setter
    def blackout_period(self, blackout_period):

        self.__blackout_period = blackout_period

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(BlackoutOperation, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BlackoutOperation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

