# coding: utf-8


"""
IGNORE:
    Nutanix Aiops Versioned APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.2-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class Node(object):
    """Node - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'node_uuid': 'str',
        'ha_memory_reserved_bytes': 'str',
        'num_cpu_threads': 'str',
        'capacity_hz': 'str',
        'memory_size_bytes': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'node_uuid': 'nodeUuid',
        'ha_memory_reserved_bytes': 'haMemoryReservedBytes',
        'num_cpu_threads': 'numCpuThreads',
        'capacity_hz': 'capacityHz',
        'memory_size_bytes': 'memorySizeBytes',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, node_uuid=None, ha_memory_reserved_bytes=None, num_cpu_threads=None, capacity_hz=None, memory_size_bytes=None, *args, **kwargs):  # noqa: E501
        """Node - a model defined in Swagger
            
        """
        self.__node_uuid = None
        self.__ha_memory_reserved_bytes = None
        self.__num_cpu_threads = None
        self.__capacity_hz = None
        self.__memory_size_bytes = None
        self.discriminator = None
        if node_uuid is not None:
            self.__node_uuid = node_uuid
        if ha_memory_reserved_bytes is not None:
            self.__ha_memory_reserved_bytes = ha_memory_reserved_bytes
        if num_cpu_threads is not None:
            self.__num_cpu_threads = num_cpu_threads
        if capacity_hz is not None:
            self.__capacity_hz = capacity_hz
        if memory_size_bytes is not None:
            self.__memory_size_bytes = memory_size_bytes
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'aiops.v4.clusterMetrics.Node'

    def _initialize_fq_object_type(self):
        return 'aiops.v4.r0.a1.clusterMetrics.Node'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def node_uuid(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__node_uuid

    @node_uuid.setter
    def node_uuid(self, node_uuid):
        if node_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', node_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `node_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__node_uuid = node_uuid

    @property
    def ha_memory_reserved_bytes(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__ha_memory_reserved_bytes

    @ha_memory_reserved_bytes.setter
    def ha_memory_reserved_bytes(self, ha_memory_reserved_bytes):

        self.__ha_memory_reserved_bytes = ha_memory_reserved_bytes

    @property
    def num_cpu_threads(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__num_cpu_threads

    @num_cpu_threads.setter
    def num_cpu_threads(self, num_cpu_threads):

        self.__num_cpu_threads = num_cpu_threads

    @property
    def capacity_hz(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__capacity_hz

    @capacity_hz.setter
    def capacity_hz(self, capacity_hz):

        self.__capacity_hz = capacity_hz

    @property
    def memory_size_bytes(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__memory_size_bytes

    @memory_size_bytes.setter
    def memory_size_bytes(self, memory_size_bytes):

        self.__memory_size_bytes = memory_size_bytes

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Node, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Node):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

