# coding: utf-8


"""
IGNORE:
    Nutanix Aiops Versioned APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.2-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_aiops_py_client.Ntnx.common.v1.config.MessageSeverity import MessageSeverity  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class AppMessage(object):
    """AppMessage - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'message': 'str',
        'severity': 'common.v1.config.MessageSeverity',
        'code': 'str',
        'locale': 'str',
        'error_group': 'str',
        'arguments_map': 'dict(str, str)',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'message': 'message',
        'severity': 'severity',
        'code': 'code',
        'locale': 'locale',
        'error_group': 'errorGroup',
        'arguments_map': 'argumentsMap',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, message=None, severity=None, code=None, locale='en_US', error_group=None, arguments_map=None, *args, **kwargs):  # noqa: E501
        """AppMessage - a model defined in Swagger
            \nThis schema is generated from AppMessage.java
        """
        self.__message = None
        self.__severity = None
        self.__code = None
        self.__locale = None
        self.__error_group = None
        self.__arguments_map = None
        self.discriminator = None
        if message is not None:
            self.__message = message
        if severity is not None:
            self.__severity = severity
        if code is not None:
            self.__code = code
        if locale is not None:
            self.__locale = locale
        if error_group is not None:
            self.__error_group = error_group
        if arguments_map is not None:
            self.__arguments_map = arguments_map
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'aiops.v4.error.AppMessage'

    def _initialize_fq_object_type(self):
        return 'aiops.v4.r0.a1.error.AppMessage'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def message(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__message

    @message.setter
    def message(self, message):

        self.__message = message

    @property
    def severity(self):
        """`{ common.v1.config.MessageSeverity }`
            
        """ # noqa: E501
        return self.__severity

    @severity.setter
    def severity(self, severity):

        self.__severity = severity

    @property
    def code(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__code

    @code.setter
    def code(self, code):

        self.__code = code

    @property
    def locale(self):
        """`{ str }`
            \nThe locale for the message description.
        """ # noqa: E501
        return self.__locale

    @locale.setter
    def locale(self, locale):

        self.__locale = locale

    @property
    def error_group(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__error_group

    @error_group.setter
    def error_group(self, error_group):

        self.__error_group = error_group

    @property
    def arguments_map(self):
        """`{ dict(str, str) }`
            
        """ # noqa: E501
        return self.__arguments_map

    @arguments_map.setter
    def arguments_map(self, arguments_map):

        self.__arguments_map = arguments_map

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AppMessage, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppMessage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

